package com.elab.core.kafka.monitor;

import com.alibaba.fastjson.JSON;
import com.elab.log.model.CatCrossIdModel;
import com.jay.monitor.data.client.ext.MqMonitorRuleCallback;
import com.jay.monitor.data.core.model.serializable.MQDataDTO;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;

@Component
public class TopicMonitorRule extends MqMonitorRuleCallback {

    @Override
    public Map<String, BiConsumer<String, MQDataDTO>> getRuleMap() {
        Map<String, BiConsumer<String, MQDataDTO>> map = new HashMap<>();

        map.put("DEFAULT_ALL", (value, mqData) -> {
            CatCrossIdModel catCrossIdModel = JSON.parseObject(value, CatCrossIdModel.class);
            mqData.setRootLogId(catCrossIdModel.get_catRootMessageId());
            mqData.setParentLogId(catCrossIdModel.get_catParentMessageId());
            // 这里不用get_catChildMessageId的原因是因为生产者是不确定下游的消费者是谁的。所以还是先把子id在监控构建中传递上级，也就是自己
            mqData.setLogId(catCrossIdModel.get_catParentMessageId());
        });

        return map;
    }
}