package com.elab.core.kafka.monitor;

import com.alibaba.fastjson.JSON;
import com.elab.log.model.CatCrossIdModel;
import com.jay.monitor.data.client.ext.MqMonitorRuleCallback;
import com.jay.monitor.data.core.model.serializable.MQDataDTO;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;

/**
 * @Module TODO
 * @Description TODO
 * @Author liukaixiong
 * @Date 2020/10/30 19:42
 */
@Component
public class TestTopicMonitorRule extends MqMonitorRuleCallback {

    @Override
    public Map<String, BiConsumer<String, MQDataDTO>> getRuleMap() {
        Map<String, BiConsumer<String, MQDataDTO>> map = new HashMap<>();

        map.put("DEFAULT_ALL", (value, mqData) -> {
            CatCrossIdModel catCrossIdModel = JSON.parseObject(value, CatCrossIdModel.class);
            mqData.setRootLogId(catCrossIdModel.get_catRootMessageId());
            mqData.setParentLogId(catCrossIdModel.get_catParentMessageId());
            mqData.setLogId(catCrossIdModel.get_catChildMessageId());
        });

        map.put("uat-mysql-dts", (value, mqData) -> {
            mqData.setGroupName("aaaa");
            mqData.setGroupKeyName("bbbb");
            mqData.setDataId("cccc");
        });

        return map;
    }
}
